/* Copyright (c) Daniel Newman 2006
 *
 * e-mail: danielnewman106@hotmail.com
 */


#include "BackgroundSurface.h"

CBackgroundSurface::CBackgroundSurface (CDisplay *Display, int nResID)
	: m_Display (Display)
{
	Display->CreateDDSurface (&m_lpSurface, 800, 600);
	LoadBackground (nResID);
}

CBackgroundSurface::~CBackgroundSurface ()
{
	if (m_lpSurface)
		m_lpSurface->Release();
}

void CBackgroundSurface::DrawBackground ()
{
	m_Display->Blt (0, 0, m_lpSurface, NULL, 0);
}

void CBackgroundSurface::LoadBackground (int nResID)
{
	// Load the JPG from the DLL
	LPPICTURE p = NULL;
	HMODULE hDLL = LoadLibrary ("Backgrounds.dll");
	if (!hDLL)
	{
		MessageBox (NULL,
			"Unable to find \"Backgrounds.dll\". Some backgrounds may not be visible.",
			"Error", MB_OK);
		return;
	}
	LoadPictureResource ("JPG", nResID, hDLL, &p);
	FreeLibrary (hDLL);
	BltIPicToDDSurface (&m_lpSurface, p);
	p->Release ();
}