/* Copyright (c) Daniel Newman 2006
 *
 * e-mail: danielnewman106@hotmail.com
 */


/* The CBackgroundSurface class stores a DirectDrawSurface
 * containing a bitmap to be used as a background. The class
 * takes care of loading the bitmap as a JPEG from the
 * Backgrounds DLL.
 */


// BackgroundSurface.h: interface for the CBackgroundSurface class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BACKGROUNDSURFACE_H__1115602B_400E_48BB_9C9A_D9F9CC23F9C0__INCLUDED_)
#define AFX_BACKGROUNDSURFACE_H__1115602B_400E_48BB_9C9A_D9F9CC23F9C0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


enum
{
	BACKGROUND_BOARD = 109,
	BACKGROUND_TITLESCREEN = 110,
	BACKGROUND_VICTORY = 111,
	BACKGROUND_GAMEOVER = 112,
	BACKGROUND_RULES = 113,
	BACKGROUND_CREDITS = 114
};

#include "ddutil.h"
#include "ipicutils.h"

class CBackgroundSurface  
{
	CDisplay *m_Display;
	LPDIRECTDRAWSURFACE m_lpSurface;
public:
	CBackgroundSurface(CDisplay *Display, int nResID);
	virtual ~CBackgroundSurface();

	void DrawBackground ();
	void LoadBackground (int nResID);
};



#endif // !defined(AFX_BACKGROUNDSURFACE_H__1115602B_400E_48BB_9C9A_D9F9CC23F9C0__INCLUDED_)
