/* Copyright (c) Daniel Newman 2006
 *
 * e-mail: danielnewman106@hotmail.com
 */


// GameState.h: interface for the CGameState class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAMESTATE_H__81968E11_08F0_404E_98AD_C1039D6D1030__INCLUDED_)
#define AFX_GAMESTATE_H__81968E11_08F0_404E_98AD_C1039D6D1030__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

enum
{
	SQUARE_EMPTY,
	SQUARE_GOAT,
	SQUARE_TIGER,
	SQUARE_INVALID
};

struct Move
{
	union
	{
		int x1;
		int SourceSquareX;
	};

	union
	{
		int y1;
		int SourceSquareY;
	};

	union
	{
		int x2;
		int TargetSquareX;
	};

	union
	{
		int y2;
		int TargetSquareY;
	};

	inline bool IsNullMove()
	{
		return x1 == -1 && y1 == -1 && x2 == -1 && y2 == -1;
	}

	inline int operator == (const Move& m)
	{
	   return x1 == m.x1 && y1 == m.y1 && x2 == m.x2 && y2 == m.y2;
	}

	inline Move (int a, int b, int c, int d)
	{
		x1 = a;
		y1 = b;
		x2 = c;
		y2 = d;
	}
};
#define NULL_MOVE Move(-1, -1, -1, -1)

#include <vector>
using namespace std;

class CGameState  
{
	int m_nSquare[5][5];
	bool m_bUsedGoat[20];
	bool m_bGoatsTurn;

public:
	CGameState();
	virtual ~CGameState();

	void Reset ();

	static bool CanMoveDownLeft (int X, int Y);
	static bool CanMoveDownRight (int X, int Y);
	static bool CanMoveUpLeft (int X, int Y);
	static bool CanMoveUpRight (int X, int Y);
	static bool IsEdgeSquare (int X, int Y);

	void DoMove (Move m);
	int GetSquare (int X, int Y);
	bool IsLegalMove (Move m);
	vector <Move> ListAllLegalMoves ();
	bool IsSquareThreatned(int X, int Y);
	static bool IsTakingMove (Move m);
	int NumGoatsTaken();
	int NumUnusedGoats();

	inline bool IsGoatsTurn () { return m_bGoatsTurn; }
	inline bool IsGoatUsed (int nGoat) { return m_bUsedGoat[nGoat]; }

};

#endif // !defined(AFX_GAMESTATE_H__81968E11_08F0_404E_98AD_C1039D6D1030__INCLUDED_)
