/* Copyright (c) Daniel Newman 2006
 *
 * e-mail: danielnewman106@hotmail.com
 */


// GoatAI.h: interface for the CGoatAI class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GOATAI_H__D213F146_85B7_4C20_95FF_13B611FA760E__INCLUDED_)
#define AFX_GOATAI_H__D213F146_85B7_4C20_95FF_13B611FA760E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GameState.h"

class CGoatAI  
{
	CGameState *m_GameState;

	Move MoveToAnyUnthreatenedSquare();
	Move OpeningMove();
	Move ProtectAnyGoatBeingThreatened(bool NewSquareMustBeUnthreatened);
	Move RandomMove();
	Move TryToGoInCorner();
	Move TryToGoOnEdge(bool MustBeUnthreatened);

		// If any goats are unused then:
	// 1: protect any goat that is being attacked
	// 2: try to go in the corner
	// 3: try to on the edge (without being attacked)

public:
	CGoatAI();
	virtual ~CGoatAI();

	Move PickMove (int Level, CGameState *GameState);
};

#endif // !defined(AFX_GOATAI_H__D213F146_85B7_4C20_95FF_13B611FA760E__INCLUDED_)
