/* Copyright (c) Daniel Newman 2006
 *
 * e-mail: danielnewman106@hotmail.com
 */


// MainMenu.cpp: implementation of the CMainMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "MainMenu.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMainMenu::CMainMenu(CDisplay *Display)
{
	m_bShowOptionsMenu = false;
	m_bCanResume = false;
	m_nHighlightedItem = -1;

	m_nOptionsTigersMustEat = OPTIONS_TIGERSMUSTEAT_5GOATS;
	m_nAnimationSpeed = OPTIONS_ANIMATION_NORMAL;
	m_nSound = OPTIONS_SOUND_YES;
	m_nMusic = OPTIONS_MUSIC_YES;

	// Initialize the RECT's
	
	// Old main menu (before "Time Attack" button added
	/*RECT r0 = { 288, 55,  512, 86 }; m_rcMenu[MENU_RESUME] = r0;
	RECT r1 = { 188, 110, 611, 143 }; m_rcMenu[MENU_PLAYASGOATS] = r1;
	RECT r2 = { 176, 165, 624, 196 }; m_rcMenu[MENU_PLAYASTIGERS] = r2;
	RECT r3 = { 311, 220, 488, 251 }; m_rcMenu[MENU_RULES] = r3;
	RECT r4 = { 281, 275, 518, 308 }; m_rcMenu[MENU_OPTIONS] = r4;
	RECT r5 = { 332, 330, 468, 361 }; m_rcMenu[MENU_EXIT] = r5;*/

	RECT r0 = { 288, 30,  512, 61 }; m_rcMenu[MENU_RESUME] = r0;
	RECT r1 = { 188, 85, 611, 118 }; m_rcMenu[MENU_PLAYASGOATS] = r1;
	RECT r2 = { 176, 140, 624, 171 }; m_rcMenu[MENU_PLAYASTIGERS] = r2;
	RECT rz = { 208, 195, 592, 228 }; m_rcMenu[MENU_TIMEATTACK] = rz;
	RECT r3 = { 311, 250, 488, 281 }; m_rcMenu[MENU_RULES] = r3;
	RECT r4 = { 281, 305, 518, 338 }; m_rcMenu[MENU_OPTIONS] = r4;
	RECT r5 = { 332, 360, 468, 391 }; m_rcMenu[MENU_EXIT] = r5;

	RECT r6 = { 100, 150, 219, 171 }; m_rcMenu[OPTIONS_SOUND] = r6;
	RECT r7 = { 631, 150, 700, 171 }; m_rcMenu[OPTIONS_SOUND_YES] = r7;
	RECT r8 = { 651, 150, 700, 171 }; m_rcMenu[OPTIONS_SOUND_NO] = r8;
	RECT r9 = { 100, 200, 212, 221 }; m_rcMenu[OPTIONS_MUSIC] = r9;
	RECT ra = { 631, 200, 700, 221 }; m_rcMenu[OPTIONS_MUSIC_YES] = ra;
	RECT rb = { 651, 200, 700, 221 }; m_rcMenu[OPTIONS_MUSIC_NO] = rb;
	RECT rc = { 100, 250, 315, 271 }; m_rcMenu[OPTIONS_ANIMATIONSPEED] = rc;
	RECT rd = { 609, 250, 700, 271 }; m_rcMenu[OPTIONS_ANIMATION_FAST] = rd;
	RECT re = { 541, 250, 700, 271 }; m_rcMenu[OPTIONS_ANIMATION_NORMAL] = re;
	RECT rf = { 601, 250, 700, 271 }; m_rcMenu[OPTIONS_ANIMATION_SLOW] = rf;
	RECT rg = { 100, 300, 420, 321 }; m_rcMenu[OPTIONS_TIGERSMUSTEAT] = rg;
	RECT rh = { 581, 300, 700, 321 }; m_rcMenu[OPTIONS_TIGERSMUSTEAT_1GOAT] = rh;
	RECT ri = { 558, 300, 700, 321 }; m_rcMenu[OPTIONS_TIGERSMUSTEAT_3GOATS] = ri;
	RECT rj = { 558, 300, 700, 321 }; m_rcMenu[OPTIONS_TIGERSMUSTEAT_5GOATS] = rj;
	RECT rk = { 559, 300, 700, 321 }; m_rcMenu[OPTIONS_TIGERSMUSTEAT_7GOATS] = rk;
	RECT rl = { 503, 300, 700, 321 }; m_rcMenu[OPTIONS_TIGERSMUSTEAT_ALLGOATS] = rl;
	RECT rm = { 347, 365, 452, 386 }; m_rcMenu[OPTIONS_BACK] = rm;

	// Load the DLL
	HMODULE hDLL = LoadLibrary ("MainMenu.dll");
	if (!hDLL)
	{
		MessageBox (NULL, "Unable to find \"MainMenu.dll\". Menu may not be visible.",
			"Error", MB_OK);
		return;
	}

	// Load each GIF from the DLL
	LoadPic(Display, hDLL, &m_lpSurface[MENU_RESUME], IDR_MAINMENUDLL_RESUME);
	LoadPic(Display, hDLL, &m_lpSurface[MENU_PLAYASGOATS], IDR_MAINMENUDLL_PLAYASGOATS);
	LoadPic(Display, hDLL, &m_lpSurface[MENU_PLAYASTIGERS], IDR_MAINMENUDLL_PLAYASTIGERS);
	LoadPic(Display, hDLL, &m_lpSurface[MENU_TIMEATTACK], IDR_MAINMENUDLL_TIMEATTACK);
	LoadPic(Display, hDLL, &m_lpSurface[MENU_RULES], IDR_MAINMENUDLL_RULES);
	LoadPic(Display, hDLL, &m_lpSurface[MENU_OPTIONS], IDR_MAINMENUDLL_OPTIONS);
	LoadPic(Display, hDLL, &m_lpSurface[MENU_EXIT], IDR_MAINMENUDLL_EXIT);
	// Options menu
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_SOUND], IDR_MAINMENUDLL_SOUND);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_TIGERSMUSTEAT], IDR_MAINMENUDLL_TIGERSMUSTEAT);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_ANIMATIONSPEED], IDR_MAINMENUDLL_ANIMTION);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_TIGERSMUSTEAT_1GOAT], IDR_MAINMENUDLL_1GOAT);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_TIGERSMUSTEAT_3GOATS], IDR_MAINMENUDLL_3GOATS);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_TIGERSMUSTEAT_5GOATS], IDR_MAINMENUDLL_5GOATS);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_TIGERSMUSTEAT_7GOATS], IDR_MAINMENUDLL_7GOATS);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_TIGERSMUSTEAT_ALLGOATS], IDR_MAINMENUDLL_ALLGOATS);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_ANIMATION_FAST], IDR_MAINMENUDLL_FAST);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_ANIMATION_NORMAL], IDR_MAINMENUDLL_NORMAL);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_ANIMATION_SLOW], IDR_MAINMENUDLL_SLOW);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_SOUND_YES], IDR_MAINMENUDLL_YES);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_SOUND_NO], IDR_MAINMENUDLL_NO);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_MUSIC_YES], IDR_MAINMENUDLL_YES);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_MUSIC_NO], IDR_MAINMENUDLL_NO);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_MUSIC], IDR_MAINMENUDLL_MUSIC);
	LoadPic(Display, hDLL, &m_lpSurface[OPTIONS_BACK], IDR_MAINMENUDLL_BACK);

	// Close the DLL
	FreeLibrary (hDLL);
}

CMainMenu::~CMainMenu()
{

}

void CMainMenu::Draw(LPDIRECTDRAWSURFACE lpTarget)
{
	HDC hdc;
	lpTarget->GetDC(&hdc);

	if (!m_bShowOptionsMenu)
	{
		if (m_bCanResume)
			DrawPic (hdc, MENU_RESUME);
		DrawPic (hdc, MENU_PLAYASGOATS);
		DrawPic (hdc, MENU_PLAYASTIGERS);
		DrawPic (hdc, MENU_TIMEATTACK);
		DrawPic (hdc, MENU_RULES);
		DrawPic (hdc, MENU_OPTIONS);
		DrawPic (hdc, MENU_EXIT);
	}
	else
	{
		DrawOption (hdc, OPTIONS_SOUND, m_nSound);
		DrawOption (hdc, OPTIONS_MUSIC, m_nMusic);
		DrawOption (hdc, OPTIONS_ANIMATIONSPEED, m_nAnimationSpeed);
		DrawOption (hdc, OPTIONS_TIGERSMUSTEAT, m_nOptionsTigersMustEat);
		DrawPic (hdc, OPTIONS_BACK);
	}

	lpTarget->ReleaseDC(hdc);
}

void CMainMenu::DrawOption(HDC hdcTarget, int nMenuItem1, int nMenuItem2)
{
	// Create a pen and brush
	DeleteObject (SelectObject (hdcTarget, GetStockObject (DC_BRUSH)));
	SetDCBrushColor (hdcTarget, 0);
	HGDIOBJ hOldPen = SelectObject (hdcTarget, CreatePen(PS_SOLID, 3,
		m_nHighlightedItem == nMenuItem1 ? 0x00FFFF : 0xFFFFFF));

	// The RoundRect covers both images, so it has the left value of
	// the left GIF and the right value of the right GIF
	RoundRect (hdcTarget, m_rcMenu[nMenuItem1].left - 8, m_rcMenu[nMenuItem1].top - 8,
		m_rcMenu[nMenuItem2].right + 8, m_rcMenu[nMenuItem2].bottom + 8, 15, 15);

	// Get the DC to the GIF file
	HDC hdcSrc;

	// Draw the GIF's inside the rect
	int Width = m_rcMenu[nMenuItem1].right - m_rcMenu[nMenuItem1].left,
		Height = m_rcMenu[nMenuItem1].bottom - m_rcMenu[nMenuItem1].top;
	m_lpSurface[nMenuItem1]->GetDC(&hdcSrc);
	TransparentBlt(hdcTarget, m_rcMenu[nMenuItem1].left, m_rcMenu[nMenuItem1].top,
		Width, Height, hdcSrc, 0, 0, Width,
		Height, 0xFFFFFF);
	m_lpSurface[nMenuItem1]->ReleaseDC(hdcSrc);
	Width = m_rcMenu[nMenuItem2].right - m_rcMenu[nMenuItem2].left,
	Height = m_rcMenu[nMenuItem2].bottom - m_rcMenu[nMenuItem2].top;
	m_lpSurface[nMenuItem2]->GetDC(&hdcSrc);
	TransparentBlt(hdcTarget, m_rcMenu[nMenuItem2].left, m_rcMenu[nMenuItem2].top,
		Width, Height, hdcSrc, 0, 0, Width,
		Height, 0xFFFFFF);
	m_lpSurface[nMenuItem2]->ReleaseDC(hdcSrc);

	// Cleanup
	DeleteObject (SelectObject(hdcTarget, hOldPen));
}

void CMainMenu::DrawPic(HDC hdcTarget, int nMenuItem)
{
	// Create a pen and brush then draw the RoundRect
	DeleteObject (SelectObject (hdcTarget, GetStockObject (DC_BRUSH)));
	SetDCBrushColor (hdcTarget, 0);
	HGDIOBJ hOldPen = SelectObject (hdcTarget, CreatePen(PS_SOLID, 3,
		m_nHighlightedItem == nMenuItem ? 0x00FFFF : 0xFFFFFF));
	RoundRect (hdcTarget, m_rcMenu[nMenuItem].left - 8, m_rcMenu[nMenuItem].top - 8,
		m_rcMenu[nMenuItem].right + 8, m_rcMenu[nMenuItem].bottom + 8, 15, 15);

	// Get the DC to the GIF file
	HDC hdcSrc;
	m_lpSurface[nMenuItem]->GetDC(&hdcSrc);

	// Draw the GIF inside the rect
	int Width = m_rcMenu[nMenuItem].right - m_rcMenu[nMenuItem].left,
		Height = m_rcMenu[nMenuItem].bottom - m_rcMenu[nMenuItem].top;
	TransparentBlt(hdcTarget, m_rcMenu[nMenuItem].left, m_rcMenu[nMenuItem].top,
		Width, Height, hdcSrc, 0, 0, Width,
		Height, 0xFFFFFF);

	// Cleanup
	DeleteObject (SelectObject(hdcTarget, hOldPen));
	m_lpSurface[nMenuItem]->ReleaseDC(hdcSrc);
}

void CMainMenu::LoadPic(CDisplay *Display, HMODULE hDLL, LPDIRECTDRAWSURFACE *lpSurf,
						int nResID)
{
	// Load the resource
	LPPICTURE p = NULL;
	LoadPictureResource ("GIF", nResID, hDLL, &p);

	// Get the size of the pic
	long HI_METRIC_WIDTH, HI_METRIC_HEIGHT;

	p->get_Width (&HI_METRIC_WIDTH);
	p->get_Height (&HI_METRIC_HEIGHT);

	HDC hdc;
	Display->GetBackBuffer()->GetDC(&hdc);
    int nPixX = GetDeviceCaps(hdc, LOGPIXELSX);
    int nPixY = GetDeviceCaps(hdc, LOGPIXELSY);
	Display->GetBackBuffer()->ReleaseDC(hdc);

	int Width = MulDiv(HI_METRIC_WIDTH,  nPixX, 2540),
		Height = MulDiv(HI_METRIC_HEIGHT, nPixY, 2540);
	
	// Create a surface the size of the pic
	Display->CreateDDSurface(lpSurf, Width, Height);	

	// Copy the surface
	BltIPicToDDSurface (lpSurf, p);
	p->Release ();
}

LPSTR CMainMenu::OnMouseDown(int X, int Y)
{
	int i, j = m_nHighlightedItem;

	switch (j)
	{
	case MENU_RESUME: return "RESUME";
	case MENU_PLAYASGOATS: return "PLAY AS GOATS";
	case MENU_PLAYASTIGERS: return "PLAY AS TIGERS";
	case MENU_TIMEATTACK: return "TIME ATTACK";
	case MENU_RULES: return "RULES";
	case MENU_OPTIONS:
		m_bShowOptionsMenu = true;
		break;
	case OPTIONS_SOUND:
		i = m_nSound;
		switch (i)
		{
		case OPTIONS_SOUND_YES:
			m_nSound = OPTIONS_SOUND_NO;
			return "SOUND NO";
		case OPTIONS_SOUND_NO:
			m_nSound = OPTIONS_SOUND_YES;
			return "SOUND YES";
		}
	case OPTIONS_MUSIC:
		i = m_nMusic;
		switch (i)
		{
		case OPTIONS_MUSIC_YES:
			m_nMusic = OPTIONS_MUSIC_NO;
			return "MUSIC NO";
		case OPTIONS_MUSIC_NO:
			m_nMusic = OPTIONS_MUSIC_YES;
			return "MUSIC YES";
		}
	case OPTIONS_ANIMATIONSPEED:
		i = m_nAnimationSpeed;
		switch (i)
		{
		case OPTIONS_ANIMATION_FAST:
			m_nAnimationSpeed = OPTIONS_ANIMATION_SLOW;
			return "ANIMATION SLOW";
		case OPTIONS_ANIMATION_NORMAL:
			m_nAnimationSpeed = OPTIONS_ANIMATION_FAST;
			return "ANIMATION FAST";
		case OPTIONS_ANIMATION_SLOW:
			m_nAnimationSpeed = OPTIONS_ANIMATION_NORMAL;
			return "ANIMATION NORMAL";
		}
	case OPTIONS_TIGERSMUSTEAT:
		i = m_nOptionsTigersMustEat;
		switch (i)
		{
		case OPTIONS_TIGERSMUSTEAT_1GOAT:
			m_nOptionsTigersMustEat = OPTIONS_TIGERSMUSTEAT_3GOATS;
			return "TIGERS MUST EAT 3 GOATS";
		case OPTIONS_TIGERSMUSTEAT_3GOATS:
			m_nOptionsTigersMustEat = OPTIONS_TIGERSMUSTEAT_5GOATS;
			return "TIGERS MUST EAT 5 GOATS";
		case OPTIONS_TIGERSMUSTEAT_5GOATS:
			m_nOptionsTigersMustEat = OPTIONS_TIGERSMUSTEAT_7GOATS;
			return "TIGERS MUST EAT 7 GOATS";
		case OPTIONS_TIGERSMUSTEAT_7GOATS:
			m_nOptionsTigersMustEat = OPTIONS_TIGERSMUSTEAT_ALLGOATS;
			return "TIGERS MUST EAT ALL GOATS";
		case OPTIONS_TIGERSMUSTEAT_ALLGOATS:
			m_nOptionsTigersMustEat = OPTIONS_TIGERSMUSTEAT_1GOAT;
			return "TIGERS MUST EAT 1 GOAT";
		}
	case OPTIONS_BACK:
		m_bShowOptionsMenu = false;
		return "BACK";
	case MENU_EXIT: return "EXIT";
	}

	return "";
}

void CMainMenu::OnMouseMove(int X, int Y)
{
	POINT Pt;
	Pt.x = X;
	Pt.y = Y;

	// We only need to repaint if the highlighted item has changed
	int nPreviousItem = m_nHighlightedItem;
	m_nHighlightedItem = -1;

	// See if the cursor is over any of the menu items
	if (!m_bShowOptionsMenu)
	{
		for (int i = MENU_RESUME; i <= MENU_EXIT; i++)
			if (PtInRect(&m_rcMenu[i], Pt))			
				m_nHighlightedItem = i;
	}
	else
	{
		for (int i = OPTIONS_SOUND; i <= OPTIONS_ANIMATIONSPEED; i++)
		{
			RECT r = { 100, m_rcMenu[i].top, 700, m_rcMenu[i].bottom };
			if (PtInRect(&r, Pt))
				m_nHighlightedItem = i;
		}
		RECT r = { m_rcMenu[OPTIONS_BACK].left - 8, m_rcMenu[OPTIONS_BACK].top - 8,
			m_rcMenu[OPTIONS_BACK].right + 8, m_rcMenu[OPTIONS_BACK].bottom + 8 };
		if (PtInRect(&r, Pt))
			m_nHighlightedItem = OPTIONS_BACK;
	}
	
	m_bMustRepaint = (nPreviousItem != m_nHighlightedItem);
}