/* Copyright (c) Daniel Newman 2006
 *
 * e-mail: danielnewman106@hotmail.com
 */

// MainMenu.h: interface for the CMainMenu class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINMENU_H__F99F3F3E_EAF8_431F_92C1_20746E7613F8__INCLUDED_)
#define AFX_MAINMENU_H__F99F3F3E_EAF8_431F_92C1_20746E7613F8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define _WIN32_WINNT 0x0500
#include <ddraw.h>
#include "ddutil.h"
#include "ipicutils.h"
#include "MainMenu Resource.h"

class CMainMenu  
{
	enum
	{
		MENU_RESUME = 1,
		MENU_PLAYASGOATS,
		MENU_PLAYASTIGERS,
		MENU_TIMEATTACK,
		MENU_RULES,
		MENU_OPTIONS,
		MENU_EXIT
	} m_nSelectedMenuItem;

	enum
	{
		OPTIONS_SOUND = (MENU_EXIT + 1),
		OPTIONS_MUSIC,
		OPTIONS_TIGERSMUSTEAT,
		OPTIONS_ANIMATIONSPEED,
		OPTIONS_BACK
	};

	enum
	{
		OPTIONS_TIGERSMUSTEAT_1GOAT = (OPTIONS_BACK + 1),
		OPTIONS_TIGERSMUSTEAT_3GOATS,
		OPTIONS_TIGERSMUSTEAT_5GOATS,
		OPTIONS_TIGERSMUSTEAT_7GOATS,
		OPTIONS_TIGERSMUSTEAT_ALLGOATS
	} m_nOptionsTigersMustEat;

	enum
	{
		OPTIONS_ANIMATION_FAST = (IDR_MAINMENUDLL_ALLGOATS + 1),
		OPTIONS_ANIMATION_NORMAL,
		OPTIONS_ANIMATION_SLOW
	} m_nAnimationSpeed;

	enum
	{
		OPTIONS_SOUND_YES = (IDR_MAINMENUDLL_SLOW + 1),
		OPTIONS_SOUND_NO
	} m_nSound;
	
	enum
	{
		OPTIONS_MUSIC_YES = (OPTIONS_SOUND_NO + 1),
		OPTIONS_MUSIC_NO
	} m_nMusic;

	bool m_bShowOptionsMenu,
		m_bCanResume,
		m_bMustRepaint;

	int m_nHighlightedItem;

	LPDIRECTDRAWSURFACE m_lpSurface[OPTIONS_SOUND_NO];
	RECT m_rcMenu[OPTIONS_MUSIC_NO];

	void DrawPic(HDC hdcTarget, int nMenuItem);
	void DrawOption(HDC hdcTarget, int nMenuItem1, int nMenuItem2);
	void LoadPic(CDisplay *Display, HMODULE hDLL, LPDIRECTDRAWSURFACE *lpSurf,
						int nResID);

public:
	CMainMenu(CDisplay *Display);
	virtual ~CMainMenu();

	void Draw(LPDIRECTDRAWSURFACE lpTarget);
	void OnMouseMove(int X, int Y);
	LPSTR OnMouseDown(int X, int Y);
	inline bool CanResume() { return m_bCanResume; }
	inline void SetCanResume(bool bCanResume) { m_bCanResume = bCanResume; }
	inline bool MustRepaint() { return m_bMustRepaint; }
	inline void ReturnToTop() { m_bShowOptionsMenu = false; }

};

#endif // !defined(AFX_MAINMENU_H__F99F3F3E_EAF8_431F_92C1_20746E7613F8__INCLUDED_)
