/* Copyright (c) Daniel Newman 2006
 *
 * e-mail: danielnewman106@hotmail.com
 */


#include "MainWindow.h"

CMainWindow::CMainWindow (HINSTANCE hInst, int nClientWidth,
						int nClientHeight, int Menu, WNDPROC lpfnWndProc)
		: m_nClientWidth (nClientWidth), m_nClientHeight (nClientHeight),
		m_dwStyle (WS_TILEDWINDOW ^ WS_MAXIMIZEBOX)
{
    WNDCLASSEX wc;
    wc.cbSize        = sizeof(wc);
#define szAppName "Goats and Tigers"
    wc.lpszClassName = szAppName;
    wc.lpfnWndProc   = lpfnWndProc;
    wc.style         = CS_VREDRAW | CS_HREDRAW;
    wc.hInstance     = hInst;
    wc.hIcon         = LoadIcon (hInst, MAKEINTRESOURCE(IDI_ICON1));
    wc.hIconSm       = LoadIcon (hInst, MAKEINTRESOURCE(IDI_ICON1));
    wc.hbrBackground = (HBRUSH)GetStockObject (BLACK_BRUSH);
    wc.lpszMenuName  = Menu ? MAKEINTRESOURCE(Menu) : NULL;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hCursor = LoadCursor (NULL, IDC_ARROW);

    if (!RegisterClassEx (&wc))
        return;

	m_hWnd = CreateWindowEx (0, szAppName, szAppName, m_dwStyle,
		0, 0, nClientWidth, nClientHeight, NULL, NULL, hInst, NULL);
	UpdateClientRect ();
	Center ();
}

void CMainWindow::UpdateClientRect ()
{
	// Adjust the size of the client area to be nClientWidth x nClientHeight

	// Get the old client area
	RECT r;
	GetClientRect (m_hWnd, &r);
	int client_width = r.right - r.left, client_height = r.bottom - r.top;

	// Get the old window area
	RECT r2;
	GetWindowRect (m_hWnd, &r2);
	int window_width = r2.right - r2.left, window_height = r2.bottom - r2.top;

	// increase the window area by the difference between the
	// current client area and the desired client area
	SetWindowPos (m_hWnd, HWND_TOP, 0, 0, window_width + m_nClientWidth - client_width,
		window_height + m_nClientHeight - client_height, 0);
}

void CMainWindow::Center ()
{
	// Get the window's width and height
	RECT r;
	GetWindowRect (m_hWnd, &r);
	int window_width = r.right - r.left,
		window_height = r.bottom - r.top;

	// Get the screen width and height
	int screen_width = GetSystemMetrics (SM_CXSCREEN),
		screen_height = GetSystemMetrics (SM_CYSCREEN);

	// Work out the screen width - window width, divide by 2
	int x = (screen_width - window_width) / 2,
		y = (screen_height - window_height) / 2;

	SetWindowPos (m_hWnd, HWND_TOP, x, y, window_width, window_height, SWP_NOZORDER);
}