/* Copyright (c) Daniel Newman 2006
 *
 * e-mail: danielnewman106@hotmail.com
 */

#include "ipicutils.h"

static LPPICTURE LoadPictureFromHGlobal(HGLOBAL hglob)
{
	IStream *stream = 0;
	CreateStreamOnHGlobal(hglob, FALSE, &stream);
	IPicture *pic;
	OleLoadPicture(stream, 0, FALSE, IID_IPicture, (void**)&pic);
	stream->Release();
	return pic;
}

bool LoadPictureResource(LPCSTR szType, int nID, HMODULE hInst, LPPICTURE* p)
{
	HRSRC hRes = FindResource (hInst, MAKEINTRESOURCE (nID), szType);

	if (!hRes)
		return FALSE;

	LPVOID pMem = LoadResource(hInst, hRes);

	if (!pMem)
		return FALSE;

	DWORD dwSize = SizeofResource (hInst, hRes);

	HGLOBAL pGlobal = GlobalAlloc(0, dwSize);
	memcpy (pGlobal, pMem, dwSize);
	*p = LoadPictureFromHGlobal(pGlobal);

	if (pGlobal)
		GlobalFree(pGlobal);
	
	return *p != NULL;
}

void BltIPicXY (HDC hDC, LPPICTURE Pic, int X, int Y)
{
	long HI_METRIC_WIDTH, HI_METRIC_HEIGHT;

	Pic->get_Width (&HI_METRIC_WIDTH);
	Pic->get_Height (&HI_METRIC_HEIGHT);

    int nPixX = GetDeviceCaps(hDC, LOGPIXELSX);
    int nPixY = GetDeviceCaps(hDC, LOGPIXELSY);

	int Width = MulDiv(HI_METRIC_WIDTH,  nPixX, 2540),
		Height = MulDiv(HI_METRIC_HEIGHT, nPixY, 2540);

	Pic->Render (hDC, 0, 0, Width, Height, 0, HI_METRIC_HEIGHT,
		HI_METRIC_WIDTH, -HI_METRIC_HEIGHT, NULL);
}

void BltIPicToDDSurfaceXY (LPDIRECTDRAWSURFACE *ppSurface, LPPICTURE Pic, int X, int Y)
{
	HDC hdc;
	if (FAILED((*ppSurface)->GetDC(&hdc)))
		return;

	BltIPicXY(hdc, Pic, X, Y);
	(*ppSurface)->ReleaseDC(hdc);
}